
open Sys

(* Header start*)
open K
open Unix

let test_run pgm_str = 
  let pgm = Parser.program Lexer.start (Lexing.from_string pgm_str) in
  K.analysis (K.botMemory, pgm)

let test_error_str pgm_str = 
  let pgm = Parser.program Lexer.start (Lexing.from_string pgm_str) in
  try 
    (try let _ =  K.analysis (K.botMemory, pgm) in "" with
    K.Error s -> String.sub s 0 7)
  with Invalid_argument _ -> ""

let redirect_f = "stdout_redirect.txt"

let test_output pgm_str = 
  (* Stdout Redirection *)
  let new_stdout = open_out redirect_f in
  let _ = Unix.dup2 (Unix.descr_of_out_channel new_stdout) Unix.stdout in
  let pgm = Parser.program Lexer.start (Lexing.from_string pgm_str) in
  let _ = K.run (K.emptyMemory, pgm) in
  let _ = flush_all() in (* Current stdout channel must be flushed *)
  let _ = close_out new_stdout in 

  let result_chan = open_in redirect_f in
  really_input_string result_chan (in_channel_length result_chan)


 
(* Header end *)

let sigterm_handler = fun signo ->
  let channel = open_out_gen [Open_creat;Open_append] 0o777 "result.txt" in
  output_string channel "T";
  Pervasives.exit 0
let _ = set_signal sigterm (Signal_handle sigterm_handler) 

let _ =
    let channel = open_out_gen [Open_creat;Open_append] 0o777 "result.txt" in
    try
      let output = test_output
"
x:=1;
y:=2;
(if (2 + (-3)) then
 (write 1; x := x+y)
else
 (write 1; y := x+y) );
(if (x + (-y)) then
 write 33
else
 write 44)
" in
      let expect = "1\n33\n" in
      if output = expect then
        output_string channel "O"
      else
        output_string channel "X"
    with
      _ -> output_string channel "E"
